/******************************************************************************
UTPlus
Copyright (c) 2005-2006 by Wormbo

This program is free software; you can redistribute and/or modify 
it under the terms of the Open Unreal Mod License version 1.1.
http://wiki.beyondunreal.com/wiki/OpenUnrealModLicense


Base class for UTPlus configuration pages.
******************************************************************************/


class UTPGUI_ConfigPageBase extends LockedFloatingWindow
    abstract;


//== InitComponent ============================================================
/**
Initialize the list of active settings.
*/
//=============================================================================

function InitComponent(GUIController InController, GUIComponent InOwner)
{
  Super.InitComponent(InController, InOwner);
  
  RemoveComponent(sb_Main);
  LoadSettings();
}


//== SaveIni ==================================================================
/**
Save the settings if not canceled.
*/
//=============================================================================

function SaveIni(optional string Value)
{
  SaveSettings();
}


//== LoadSettings =============================================================
/**
Load the settings here. Should be subclassed.
*/
//=============================================================================

function LoadSettings();


//== SaveSettings =============================================================
/**
Save the settings here. Should be subclassed.
*/
//=============================================================================

function SaveSettings();


//=============================================================================
// Default properties
//=============================================================================

defaultproperties
{
  bMoveAllowed = False
}
