/******************************************************************************
UTPlus
Copyright (c) 2005-2006 by Wormbo

This program is free software; you can redistribute and/or modify 
it under the terms of the Open Unreal Mod License version 1.1.
http://wiki.beyondunreal.com/wiki/OpenUnrealModLicense


A slider for demo playback speed.
******************************************************************************/


class UTPGUI_SpeedSlider extends GUISlider;


//== delegate OnStartSliding ==================================================
/**
Called when the user starts dragging the slider.
*/
//=============================================================================

delegate OnStartSliding();


//== delegate OnEndSliding ====================================================
/**
Called when the user stops dragging the slider.
*/
//=============================================================================

delegate OnEndSliding();


//== GetValueString ===========================================================
/**
Returns the speed factor as a string.
*/
//=============================================================================

function string GetValueString()
{
  if ( Value < 0 )
    return "x1/" $ int(1 / 2 ** int(Value));
	return "x" $ int(2 ** int(Value));
}


//== InternalOnMousePressed ===================================================
/**
Start dragging the slider.
*/
//=============================================================================

function InternalOnMousePressed(GUIComponent Sender, bool bRepeatClick)
{
  Super.InternalOnMousePressed(Sender, bRepeatClick);
  OnStartSliding();
}


//== InternalOnMouseRelease ===================================================
/**
Stop dragging the slider.
*/
//=============================================================================

function InternalOnMouseRelease(GUIComponent Sender)
{
  Super.InternalOnMouseRelease(Sender);
  OnEndSliding();
}


//=============================================================================
// Default properties
//=============================================================================

defaultproperties
{
  OnDrawCaption=GetValueString
  bShowCaption=True
  bShowValueTooltip=False
  bIntSlider=True
  MinValue=-2
  MaxValue=2
}
