/******************************************************************************
UTPlus
Copyright (c) 2005-2006 by Wormbo

This program is free software; you can redistribute and/or modify 
it under the terms of the Open Unreal Mod License version 1.1.
http://wiki.beyondunreal.com/wiki/OpenUnrealModLicense


Global clientside settings for UTPlus.
******************************************************************************/


class UTP_ClientSettings extends Object
    abstract
    config(UTPlusClientSettings);


//=============================================================================
// Configuration
//=============================================================================

// Player visibility
var(DeRes) config bool bInstantDeRes;
var(DeRes) config bool bRisingDeRes;
var(DeRes) config bool bTeamDeRes;
var(DeRes) config bool bSkipLeaveBodyEffect;

// ping compensation
var(Ping) config enum EPingCompensationType {
  Off,
  PredictionOnly,
  PredictionPreferred,
  ServerPreferred,
  ServerOnly,
} PingCompensationPlayers;
var(Ping) config bool bPingCompensationProjectiles;
var(Ping) config byte PingSmoothing;

// HitSounds
var(HitSounds) config int   HitSoundEnemy;
var(HitSounds) config int   HitSoundVehicle;
var(HitSounds) config int   HitSoundEmptyVehicle;
var(HitSounds) config int   HitSoundProtected;
var(HitSounds) config int   HitSoundTeam;
var(HitSounds) config float HitSoundVolume;
var(HitSounds) config bool  bVariableHitSounds;

// demo recording
var(Misc) config bool   bAutoScreenshot     "automatic scoreboard screenshot at the end of a match";
var(Misc) config string AutoScreenshotName  "file name for auto-screenshots";
var(Misc) config bool   bAutoDemoRecording  "automatic client demo recording";
var(Misc) config string AutoDemoName        "file name for automatically recorded demos";
var(Misc) config bool   bEnableClientPlayerIDDB;
var(Misc) config bool   bLogUTPlusConsoleActivity;
var(Misc) config bool   bCalcPathsDuringGame;

var(HUD) config bool bDisplayConnectionStatus;
var(HUD) config bool bDisplayPingGraph;
var(HUD) config bool bConstantCrosshairSize;
var(HUD) config bool bNoDamageIndicators;
var(HUD) config bool bDrawPathStatus;

var(Audio) config bool  bPlayOwnLandingSound;
var(Audio) config float RolloffFactor;

var(TeamBeacons) config bool bHideSpectatorBeacons;


//=============================================================================
// Default configuration
//=============================================================================

defaultproperties
{
  // player visibility
  bInstantDeRes = True
  bRisingDeRes  = False
  bTeamDeRes    = True
  bSkipLeaveBodyEffect = True;
  
  // hit sounds
  HitSoundEnemy         = 0
  HitSoundVehicle       = 2
  HitSoundEmptyVehicle  = 9
  HitSoundProtected     = 7
  HitSoundTeam          = 6
  HitSoundVolume        = 1.5
  bVariableHitSounds    = True
  
  // ping compensation 
  PingCompensationPlayers       = ServerPreferred
  bPingCompensationProjectiles  = True
  PingSmoothing                 = 20
  
  // misc
  bAutoScreenshot           = False
  AutoScreenshotName        = "%d_%t_%g_%m"
  bAutoDemoRecording        = False
  AutoDemoName              = "%d_%t_%g_%m"
  bEnableClientPlayerIDDB   = True
  bLogUTPlusConsoleActivity = True
  
  bHideSpectatorBeacons = False
  
  bDisplayConnectionStatus  = True
  
  bConstantCrosshairSize  = False
  bNoDamageIndicators     = False
  bDrawPathStatus         = True
  bCalcPathsDuringGame    = False
  
  bPlayOwnLandingSound  = True
  RolloffFactor         = 0.5
}