/******************************************************************************
UTPlus
Copyright (c) 2005-2006 by Wormbo

This program is free software; you can redistribute and/or modify 
it under the terms of the Open Unreal Mod License version 1.1.
http://wiki.beyondunreal.com/wiki/OpenUnrealModLicense


Booster combo for Q-Mode.
******************************************************************************/


class UTP_ComboDefensive extends ComboDefensive;


//== StartEffect ==============================================================
/**
Modify the pawn's health drain.
*/
//=============================================================================

function StartEffect(xPawn P)
{
  if (P.Role == ROLE_Authority) {
    Effect = Spawn(class'RegenCrosses', P,, P.Location, P.Rotation);
    if (UTP_Pawn(P) != None) {
      UTP_Pawn(P).HealthDrain = 5;
      UTP_Pawn(P).ShieldDrain = 0;
    }
  }
  SetTimer(1.1, true);
  Timer();
}


//== Timer ====================================================================
/**
Regenerate shield points when health is full.
*/
//=============================================================================

function Timer()
{
  if (Pawn(Owner).Role == ROLE_Authority && Pawn(Owner).Health == Pawn(Owner).SuperHealthMax )
    Pawn(Owner).AddShieldStrength(5);
}


//== StopEffect ===============================================================
/**
Reset the pawn's health drain.
*/
//=============================================================================

function StopEffect(xPawn P)
{
  if ( Effect != None )
    Effect.Destroy();
  if (UTP_Pawn(P) != None) {
    UTP_Pawn(P).HealthDrain = UTP_Pawn(P).default.HealthDrain;
    UTP_Pawn(P).ShieldDrain = UTP_Pawn(P).default.ShieldDrain;
  }
}


//=============================================================================
// Default properties
//=============================================================================

defaultproperties
{
  Duration = 45.0
}