/******************************************************************************
UTPlus
Copyright (c) 2005-2006 by Wormbo

This program is free software; you can redistribute and/or modify 
it under the terms of the Open Unreal Mod License version 1.1.
http://wiki.beyondunreal.com/wiki/OpenUnrealModLicense


Global demo playback settings for UTPlus.
******************************************************************************/


class UTP_DemoPlaybackSettings extends Object
    abstract
    config(UTPlusClientSettings);


//=============================================================================
// Structs
//=============================================================================

struct TFrameRatePreset {
  var() config array<int> Presets;
  var() config int        LastValue;
};


//=============================================================================
// Configuration
//=============================================================================

var(BehindView)     config vector           Player3rdPersonOffset;
var(BehindView)     config vector           Player3rdPersonViewOffset;
var(BehindView)     config float            Free3rdPersonViewTurnRate;
var(BehindView)     config float            Free3rdPersonViewPitchRate;

var(ChaseCam)       config float            MaxChaseCamSpeed;
var(ChaseCam)       config float            PlayerChaseSpeedFalloff;
var(ChaseCam)       config float            ChaseCamAcceleration;
var(ChaseCam)       config float            ChaseCamPlayerRepulse;
var(ChaseCam)       config vector           PlayerChaseOffset;
var(ChaseCam)       config vector           PlayerChaseViewOffset;

var(ProjectileCam)  config float            MaxProjectileCamSpeed;
var(ProjectileCam)  config float            ProjectileChaseSpeedFalloff;
var(ProjectileCam)  config float            ProjectileCamAcceleration;
var(ProjectileCam)  config vector           ProjectileChaseOffset;
var(ProjectileCam)  config vector           ProjectileChaseViewOffset;
var(ProjectileCam)  config float            ProjectileImpactSwitchDelay;

var(FreeFlight)     config vector           FreeFlightAxisSpeeds;
var(FreeFlight)     config float            FreeFlightTurnRate;
var(FreeFlight)     config float            FreeFlightPitchRate;
var(FreeFlight)     config float            VelocityFadeTime;
var(FreeFlight)     config bool             bVerticalUpDown;

var(DemoPlayback)   config bool             bForceRegularModels;
var(DemoPlayback)   config bool             bForceRegularSkins;
var(DemoPlayback)   config class<GUIPage>   DemoPlaybackMenu;
var(DemoPlayback)   config bool             bFadeOnViewChange;
var(DumpFrames)     config TFrameRatePreset DumpFrameRatePreset;

var(Compatibility)  config array<string>    CustomDemoInteractions;


//=============================================================================
// Default configuration
//=============================================================================

defaultproperties
{
  Player3rdPersonOffset       = (X=-250,Z=+80)
  Player3rdPersonViewOffset   = (X=+50,Z=+20)
  Free3rdPersonViewTurnRate   = 100.0
  Free3rdPersonViewPitchRate  = 100.0
  
  MaxChaseCamSpeed        = 1500.0
  PlayerChaseSpeedFalloff = 2.0
  ChaseCamAcceleration    = 2000.0
  ChaseCamPlayerRepulse   =  500.0
  PlayerChaseOffset       = (X=-300,Z=+100)
  PlayerChaseViewOffset   = (X=+50,Z=+20)
  
  MaxProjectileCamSpeed       = 3000.0
  ProjectileChaseSpeedFalloff = 3.0
  ProjectileCamAcceleration   = 5000.0
  ProjectileChaseOffset       = (X=-150,Z=+50)
  ProjectileChaseViewOffset   = (X=+50)
  ProjectileImpactSwitchDelay = 0.5
  
  FreeFlightAxisSpeeds  = (X=800.0,Y=800.0,Z=800.0)
  FreeFlightTurnRate    = 100.0
  FreeFlightPitchRate   = 100.0
  VelocityFadeTime      = 0.2
  bVerticalUpDown       = True
  
  bForceRegularModels = True
  bForceRegularSkins  = True
  DemoPlaybackMenu    = UTPGUI_DemoPlaybackMenu
  bFadeOnViewChange   = True
  DumpFrameRatePreset = (Presets=(15,20,24,25,30,50,60),LastValue=30)
}