/******************************************************************************
UTPlus
Copyright (c) 2005-2006 by Wormbo

This program is free software; you can redistribute and/or modify 
it under the terms of the Open Unreal Mod License version 1.1.
http://wiki.beyondunreal.com/wiki/OpenUnrealModLicense


Tries to compensate ping for network clients.
The class name does not include "UTPlus" so the mutator can be filtered
together with the stand-alone ping compensation mutator without requiring an
additional server filter.
******************************************************************************/


class UTP_PawnCollision extends Actor
    notplaceable;


//=============================================================================
// Variables
//=============================================================================

var UTP_Pawn UnlaggedPawn;


//== TakeDamage ===============================================================
/**
Spawn and enable the unlagged collision cylinder for a UTP_Pawn.
*/
//=============================================================================

event TakeDamage(int Damage, Pawn EventInstigator, vector HitLocation, vector Momentum, class<DamageType> DamageType)
{
  if (CollisionRadius > 0 && UnlaggedPawn != None) {
    //log("Damaging"@UnlaggedPawn@"instead of"@self);
    UnlaggedPawn.TakeDamage(Damage, EventInstigator, HitLocation + (UnlaggedPawn.Location - Location), Momentum, DamageType);
  }
}


//=============================================================================
// Default properties
//=============================================================================

defaultproperties
{
  bHidden = True
  RemoteRole = ROLE_None
  bCollideWorld = False
  bCollideActors = False
  bBlockActors = False
}