/******************************************************************************
UTPlus
Copyright (c) 2005-2006 by Wormbo

This program is free software; you can redistribute and/or modify 
it under the terms of the Open Unreal Mod License version 1.1.
http://wiki.beyondunreal.com/wiki/OpenUnrealModLicense


Fix for assault grenade fire.
******************************************************************************/


class UTP_AssaultGrenade extends AssaultGrenade;


//== SpawnProjectile ==========================================================
/**
Fix for Grenade.SpawnProjectile. Respects the ProjectileClass variable.
*/
//=============================================================================

function Projectile SpawnProjectile(vector Start, rotator Dir)
{
  local Projectile g;
  local vector X, Y, Z;
  local float pawnSpeed;
  
  g = Weapon.Spawn(ProjectileClass, Instigator,, Start, Dir);
  if (g != None) {
    Weapon.GetViewAxes(X, Y, Z);
    pawnSpeed = X dot Instigator.Velocity;
    
    if ( Bot(Instigator.Controller) != None )
      g.Speed = mHoldSpeedMax;
    else
      g.Speed = mHoldSpeedMin + HoldTime * mHoldSpeedGainPerSec;
    g.Speed = FClamp(g.Speed, mHoldSpeedMin, mHoldSpeedMax);
    g.Speed = pawnSpeed + g.Speed;
    g.Velocity = g.Speed * vector(Dir);
    
    g.Damage *= DamageAtten;
  }
  return g;
}


//=============================================================================
// Default properties
//=============================================================================

defaultproperties
{
  ProjectileClass = Class'UTP_Grenade'
}
