/******************************************************************************
UTPlus
Copyright (c) 2005-2006 by Wormbo

This program is free software; you can redistribute and/or modify 
it under the terms of the Open Unreal Mod License version 1.1.
http://wiki.beyondunreal.com/wiki/OpenUnrealModLicense


Accumulates damage for hit sound pitch calculation and plays hit sounds.
******************************************************************************/


class UTP_HitSounds extends Info;


//=============================================================================
// Variables
//=============================================================================

/*var float AccumulatedPlayerDamage;      // total enemy damage dealt out in the last time interval
var float AccumulatedVehicleDamage;     // total enemy damage dealt out in the last time interval
var bool bProtectedHit;                 // indicates a hit when the victim had respawn protection
var bool bTeamHit;                      // indicates a team hit in the last time interval
var bool bEmptyVehicleHit;              // indicates a hit to an empty vehicle in the last time interval
*/
var bool bAllowVariableHitSounds;       // whether variable hitsound pitch should be calculated
var UTP_PlayerReplicationInfo MyReplication;
var bool bUpdated;


//== DispatchHitSounds ========================================================
/**
Calculates a hit sound pitch from the accumulated damage and plays a hit sound if any damage was dealt out.
*/
//=============================================================================

/*function DispatchHitSounds()
{
  local float HitSoundPitchPlayer;
  local float HitSoundPitchVehicle;
  
  if ( AccumulatedPlayerDamage > 0 ) {
    if ( bAllowVariableHitSounds )
      HitSoundPitchPlayer = 1.5 - FClamp((AccumulatedPlayerDamage - 10) / 100, 0.0, 1.3);
    else
      HitSoundPitchPlayer = -1;
  }
  if ( AccumulatedVehicleDamage > 0 ) {
    if ( bAllowVariableHitSounds )
      HitSoundPitchVehicle = 1.5 - FClamp((AccumulatedVehicleDamage - 10) / 100, 0.0, 1.3);
    else
      HitSoundPitchVehicle = -1;
  }
  
  if ( (AccumulatedPlayerDamage > 0 || AccumulatedVehicleDamage > 0 || bTeamHit || bProtectedHit || bEmptyVehicleHit) ) {
    if ( MyReplication == None )
      MyReplication = class'UTP_PlayerReplicationInfo'.static.FindFor(Owner);
    if ( MyReplication == None ) {
      Destroy();
      return;
    }
    MyReplication.ClientPlayHitSound(HitSoundPitchPlayer, HitSoundPitchVehicle, bTeamHit, bProtectedHit, bEmptyVehicleHit);
  }
  
  AccumulatedPlayerDamage   = 0;
  AccumulatedVehicleDamage  = 0;
  bTeamHit                  = False;
  bEmptyVehicleHit          = False;
  bProtectedHit             = False;
}*/


//== AddDamage ================================================================
/**
Accumulates the damage dealt out by the player.
*/
//=============================================================================

function AddDamage(int Damage, Pawn Victim)
{
  /*if ( PlayerController(Owner) == None ) {
    Destroy();
    return;
  }*/
  if ( MyReplication == None ) {
    MyReplication = UTP_PlayerReplicationInfo(Owner);
    if ( Level.NetMode != NM_DedicatedServer )
      SetTimer(0.05, True);
  }
  if ( MyReplication == None || Victim == None || Victim.Controller == MyReplication.Owner || Victim.PlayerReplicationInfo == MyReplication.AssociatedPRI ) {
    return;
  }
  if ( Vehicle(Victim) != None && !Vehicle(Victim).bDriving ) {
    if ( Victim.GetTeamNum() == 255 || Controller(MyReplication.Owner).GetTeamNum() == 255 || Controller(MyReplication.Owner).GetTeamNum() != Victim.GetTeamNum() ) {
      if ( Vehicle(Victim).bSpawnProtected ) {
        //bProtectedHit = True;
        MyReplication.AccumulatedProtectedHits++;
      }
      else {
        //bEmptyVehicleHit = True;
        MyReplication.AccumulatedEmptyVehicleHits++;
      }
    }
    else {
      //bTeamHit = True;
      MyReplication.AccumulatedFriendlyHits++;
    }
  }
  else if ( Controller(MyReplication.Owner).SameTeamAs(Victim.Controller) ) {
    //bTeamHit = True;
    MyReplication.AccumulatedFriendlyHits++;
  }
  else if ( Level.TimeSeconds - Victim.SpawnTime < DeathMatch(Level.Game).SpawnProtectionTime ) {
    //bProtectedHit = True;
    MyReplication.AccumulatedProtectedHits++;
  }
  else if ( Damage > 0 ) {
    if ( Vehicle(Victim) != None ) {
      //AccumulatedVehicleDamage += Damage;
      if ( bAllowVariableHitSounds )
        MyReplication.AccumulatedVehicleDamage += Damage;
      else
        MyReplication.AccumulatedVehicleHits++;
    }
    else {
      //AccumulatedPlayerDamage += Damage;
      if ( bAllowVariableHitSounds )
        MyReplication.AccumulatedEnemyDamage += Damage;
      else
        MyReplication.AccumulatedEnemyHits++;
    }
  }
  bUpdated = True;
}


//== Timer ====================================================================
/**
checks for hitsound updates on the listen server or in a standalone game.
*/
//=============================================================================

function Timer()
{
  if ( bUpdated && MyReplication != None )
    MyReplication.PostNetReceive();
  else if ( MyReplication == None )
    Destroy();
  bUpdated = False;
}
