/******************************************************************************
UTPlus
Copyright (c) 2005-2006 by Wormbo

This program is free software; you can redistribute and/or modify 
it under the terms of the Open Unreal Mod License version 1.1.
http://wiki.beyondunreal.com/wiki/OpenUnrealModLicense


UTPlus Q-Mode GameRules.
******************************************************************************/


class UTP_QModeGameRules extends GameRules;


//== OverridePickupQuery ======================================================
/**
Notify extensions of item pickup events.
*/
//=============================================================================

function bool OverridePickupQuery(Pawn Other, Pickup Item, out byte bAllowPickup)
{
  local bool bOverride;
  local Weapon AlreadyHas;
  
  bOverride = Super.OverridePickupQuery(Other, Item, bAllowPickup);
  if ( (!bOverride || bool(bAllowPickup)) && WeaponPickup(Item) != None ) {
    AlreadyHas = Weapon(Other.FindInventoryType(Item.InventoryType));
    if (AlreadyHas != None && AlreadyHas.Class == Item.InventoryType) {
      AlreadyHas.AddAmmo(1, 0);
      if (AlreadyHas.GetAmmoClass(0) != AlreadyHas.GetAmmoClass(1))
        AlreadyHas.AddAmmo(1, 1);
      if (!Other.Inventory.HandlePickupQuery(Item)) {
        Item.AnnouncePickup(Other);
        Item.SetRespawn();
        bOverride = True;
        bAllowPickup = 0;
      }
      AlreadyHas.FillToInitialAmmo();
    }
  }
  return bOverride;
}


//=============================================================================
// Default properties
//=============================================================================

defaultproperties
{
}