/******************************************************************************
UTPlus
Copyright (c) 2005-2006 by Wormbo

This program is free software; you can redistribute and/or modify 
it under the terms of the Open Unreal Mod License version 1.1.
http://wiki.beyondunreal.com/wiki/OpenUnrealModLicense


Fix for multi rocket fire.
******************************************************************************/


class UTP_RocketMultiFire extends RocketMultiFire;


//== SpawnProjectile ==========================================================
/**
Fix for RocketLauncher.SpawnProjectile. Respects the ProjectileClass variable.
*/
//=============================================================================

function Projectile SpawnProjectile(Vector Start, Rotator Dir)
{
  local SeekingRocketProj SeekingRocket;
  local Bot B;
  
  RocketLauncher(Weapon).bBreakLock = true;
  
  // decide if bot should be locked on
  B = Bot(Instigator.Controller);
  if ( B != None && B.Skill > 2 + 5 * FRand() && FRand() < 0.6 && B.Target != None && B.Target == B.Enemy && VSize(B.Enemy.Location - B.Pawn.Location) > 2000 + 2000 * FRand() && Level.TimeSeconds - B.LastSeenTime < 0.4 && Level.TimeSeconds - B.AcquireTime > 1.5 ) {
    RocketLauncher(Weapon).bLockedOn = true;
    RocketLauncher(Weapon).SeekTarget = B.Enemy;
  }
  
  SeekingRocket = SeekingRocketProj(Spawn(ProjectileClass,,, Start, Dir));
  if (RocketLauncher(Weapon).bLockedOn && SeekingRocket != None && RocketLauncher(Weapon).SeekTarget != None) {
    SeekingRocket.Seeking = RocketLauncher(Weapon).SeekTarget;
    if ( B != None ) {
      //log("LOCKED");
      RocketLauncher(Weapon).bLockedOn = false;
      RocketLauncher(Weapon).SeekTarget = None;
    }
  }
  
  if ( SeekingRocket != None )
    SeekingRocket.Damage *= DamageAtten;
  return SeekingRocket;
}


//=============================================================================
// Default properties
//=============================================================================

defaultproperties
{
  ProjectileClass = Class'UTP_RocketProj'
}
