/******************************************************************************
UTPlus
Copyright (c) 2005-2006 by Wormbo

This program is free software; you can redistribute and/or modify 
it under the terms of the Open Unreal Mod License version 1.1.
http://wiki.beyondunreal.com/wiki/OpenUnrealModLicense


InstaGib with lag compensation.
******************************************************************************/


class UTP_UnlaggedSuperShockBeamFire extends ZoomSuperShockBeamFire;


//== DoFireEffect =============================================================
/**
Perform trace with unlagged pawns.
*/
//=============================================================================

function DoFireEffect()
{
  local Mutator M;
  
  if (Level.Game != None) {
    for (M = Level.Game.BaseMutator; M != None; M = M.NextMutator) {
      if (M.Tag == 'UnlagPawns')
        M.Trigger(Weapon, Instigator);
    }
  }
  Super.DoFireEffect();
  if (Level.Game != None) {
    for (M = Level.Game.BaseMutator; M != None; M = M.NextMutator) {
      if (M.Tag == 'UnlagPawns')
        M.Untrigger(Weapon, Instigator);
    }
  }
}


//== TracePart ================================================================
/**
Damage the Pawn instead when hitting an unlagged collision cylinder.
*/
//=============================================================================

function TracePart(vector Start, vector End, vector X, rotator Dir, Pawn Ignored)
{
  local vector HitLocation, HitNormal;
  local Actor Other;
  
  Other = Ignored.Trace(HitLocation, HitNormal, End, Start, true);
  
  if ( Other != None && Other != Ignored ) {
    if ( !Other.bWorldGeometry ) {
      Other.TakeDamage(DamageMax, Instigator, HitLocation, Momentum * X, DamageType);
      HitNormal = vect(0,0,0);
      if (Pawn(Other) != None && HitLocation != Start && ZoomSuperShockRifle(Weapon) != None && AllowMultiHit())
        TracePart(HitLocation, End, X, Dir, Pawn(Other));
    }
  }
  else {
    HitLocation = End;
    HitNormal = vect(0,0,0);
  }
  SpawnBeamEffect(Start, Dir, HitLocation, HitNormal, 0);
}


//=============================================================================
// Default properties
//=============================================================================

defaultproperties
{
}
