/******************************************************************************
UTPlus
Copyright (c) 2005-2006 by Wormbo

This program is free software; you can redistribute and/or modify 
it under the terms of the Open Unreal Mod License version 1.1.
http://wiki.beyondunreal.com/wiki/OpenUnrealModLicense


Holds an ID unique to a server (INI file).
******************************************************************************/


class UTP_DataStorageID extends Object;


//=============================================================================
// Configuration
//=============================================================================

var private config editconst const string _Notice_;
var private config editconst int ServerID;


//== static GetServerID =======================================================
/**
Returns the server ID. If it is not valid, a new ID will be generated first.
*/
//=============================================================================

static final function int GetServerID()
{
  if ( default.ServerID <= 0 ) {
    do {
      default.ServerID = Rand(MaxInt);
    } until (default.ServerID > 0);
    StaticSaveConfig();
  }
  return default.ServerID;
}


//=============================================================================
// Default properties
//=============================================================================

defaultproperties
{
  _Notice_=" The ServerID will be appended to all UTPlus data storage packages to make them unique for every server run from this directory."
}
